> For the complete documentation index, see [llms.txt](https://infinitode-docs.gitbook.io/documentation/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://infinitode-docs.gitbook.io/documentation/api-documentation/quadratic-equation-solver-api-documentation.md).

# Quadratic Equation Solver API Documentation

This API allows you to calculate the roots of a given quadratic equation.

## :rocket: Quickstart Using cURL

```bash
curl -X POST "https://infinitode.netlify.app/api/v1/quadratic-equation-solver" \
     -H "Content-Type: application/json" \
     -d '{"apiKey": "YOUR_API_TOKEN", "a": 2, "b": 5, "c": -8}'
```

## Changelog

* **1.1 (Latest)**: Updated API security.
* **1.0**: Initial commit for API space.

## Access

The API can be accessed from

```html
https://infinitode.netlify.app/api/v1/quadratic-equation-solver
```

***

## Authentication

### Bearer

This API uses Bearer Token authentication. Include your API token in the `Authorization` header of your request.

```
Authorization: Bearer YOUR_API_TOKEN
```

{% hint style="info" %}
You can also use the API with the default `GET` method, and continue to use the default `apiKey` or `token` parameters. When using the authorization bearer, `apiKey` or `token` parameters are automatically ignored.
{% endhint %}

### API Token

To use this API, you must include an API token in the request. The API token should be included in the request body as the `apiKey` field.

```json
{
  "apiKey": "YOUR_API_TOKEN"
}
```

You can also use the API with the default `GET` method.

```url
https://infinitode.netlify.app/api/v1/quadratic-equation-solver?token=YOUR_API_TOKEN
```

***

## Endpoint

### Calculate the roots

Endpoint URL:

```
https://infinitode.netlify.app/api/v1/quadratic-equation-solver
```

HTTP Methods:

* `Post`
* `Get`

Request Body

The request body should be a JSON object with the following properties:

* `apiKey`: Your API token.
* `a`: First parameter in the equation (**`a`**&#x78;^2 + bx + c)
* `b`: Second parameter in the equation. (ax^2 + **`b`**&#x78; + c)
* `c`: Third parameter in the equation. (ax^2 + bx + **`c`**)

Example:

```json
{
  "apiKey": "YOUR_API_TOKEN",
  "a": 2,
  "b": 5,
  "c": -8
}
```

Or, use the `GET` method:

{% code overflow="wrap" %}

```url
https://infinitode.netlify.app/api/v1/bmi?token=YOUR_API_TOKEN&a=2&b=5&c=-8
```

{% endcode %}

Response

Upon a successful request, you will receive a JSON response with the calculated BMI. If the API token is invalid or the request fails for any reason, an error message will be included in the response. For developer API calls, validation results will also be included along with **dummy content**.

Example response:

```json
{
  "roots": [
		1.1084952830141508,
		-3.608495283014151
	]
}
```

The response includes the calculated roots and validation results for the inputs are excluded, since this was a normal API call.

***

## Usage example

Here's a usage example in JavaScript using the `fetch` API:

```javascript
const apiUrl = 'https://infinitode.netlify.app/api/v1/quadratic-equation-solver';

const data = {
  "apiKey": "YOUR_API_TOKEN",
  "a": 2,
  "b": 5,
  "c": -8
};

fetch(apiUrl, {
  method: 'POST',
  headers: {
    'Content-Type': 'application/json',
  },
  body: JSON.stringify(data),
})
  .then(response => response.json())
  .then(result => {
    console.log('Roots:', result.roots);
  })
  .catch(error => {
    console.error('Error:', error);
  });
```

Make sure to replace `'YOUR_API_TOKEN'` with your actual API token.

{% hint style="warning" %}
This example puts your API key in the code. That's fine for local testing, or with your **developer** key. Don't ship your **normal** key in a public website or app: anyone can open the browser's developer tools, copy it, and spend your calls. In production, call the API from your own server or a serverless function, and have your front end call that. See [Keeping your API key safe](/documentation/api-documentation/keeping-your-api-key-safe.md).
{% endhint %}

***

## Error handling

The API may return error responses in case of invalid input or other issues. Be sure to handle errors gracefully in your application. Error responses will include appropriate status codes and error messages in the JSON format.

***

## Parameters

Here are all the available parameters for the API:

#### `POST` method

| Parameter | Description                                                           | Optional |
| --------- | --------------------------------------------------------------------- | -------- |
| `apiKey`  | Your API key, either the developer API key, or your normal API key    | `false`  |
| `a`       | First parameter (number) in the equation (**`a`**&#x78;^2 + bx + c)   | `false`  |
| `b`       | Second parameter (number) in the equation. (ax^2 + **`b`**&#x78; + c) | `false`  |
| `c`       | Third parameter (number) in the equation. (ax^2 + bx + **`c`**)       | `false`  |

#### `GET` method

| Parameter | Description                                                           | Optional |
| --------- | --------------------------------------------------------------------- | -------- |
| `token`   | Your API key, either the developer API key, or your normal API key    | `false`  |
| `a`       | First parameter (number) in the equation (**`a`**&#x78;^2 + bx + c)   | `false`  |
| `b`       | Second parameter (number) in the equation. (ax^2 + **`b`**&#x78; + c) | `false`  |
| `c`       | Third parameter (number) in the equation. (ax^2 + bx + **`c`**)       | `false`  |

***

## :warning: Error codes

Here are a few of the error codes, you will receive in responses, to help clarify issues:

#### Common error codes

<table><thead><tr><th width="177">Error code</th><th>Description</th></tr></thead><tbody><tr><td><code>400</code></td><td>Missing or invalid parameters. This is when the parameters you passed to the API, do not match the API's expected inputs.</td></tr><tr><td><code>405</code></td><td>Using an invalid method, to access the API.</td></tr><tr><td><code>429</code></td><td>The rate limit is exceeded within the current timeframe.</td></tr><tr><td><code>401</code></td><td>Invalid API key, no remaining calls (<code>No remaining API calls.</code> / <code>No remaining developer API calls.</code>), or an error while processing your input.</td></tr></tbody></table>

{% hint style="info" %}
Our APIs are rigorously tested before deployments, to ensure that they do not produce any unintentional errors during production.
{% endhint %}

***

## :hourglass: Rate limiting

We use rate limiting, to protect our API's resources. Rate limiting is implemented on all of our APIs, and follows these general principles:

* `interval`: The rate limiting is set to a default interval of `1 minute`.
* `amount of requests`: The amount of requests is set to a default of `25 requests` within the given interval.

If the rate limit is exceeded, an error `429` code will be returned, instead of the actual API output.

***

## :star: Best practices

Common guidelines to use, optimize, and protect your implementation of our APIs.

* Do not store/share/expose your API keys. See [Keeping your API key safe](/documentation/api-documentation/keeping-your-api-key-safe.md)
* Implement data cleaning, and validation in your code, to ensure inputs are sanitized
* Handle API errors gracefully
* Use Developer API calls, to help debug your implementation and code
* Handle API outputs accordingly. You can see examples of this API's output in the [#endpoint](#endpoint "mention") section.
* Implement code to notify users of actions when using our APIs, such as errors, delays, formatting issues, etc.

***

## :question: FAQs

Answers to the most common questions and issues when using this API:

<details>

<summary>I am getting a <code>405</code> error, what should I do?</summary>

A `405` error means the endpoint exists, but the HTTP method doesn't: use `POST` or `GET`, since this endpoint does not accept other HTTP methods. A `404` or `NotFound` error is different — it means the route doesn't exist, usually because the endpoint URL was misspelled.

</details>

<details>

<summary>Is rate limiting set individually, or per API key?</summary>

Rate limiting is set `individually`, this means that rate limiting happens on an end-user level. This ensures that our API is used fairly, among all users.

</details>

<details>

<summary>Are request timeouts a thing?</summary>

Yes, we normally timeout requests after the 10-second mark. This, however, can vary significantly, depending on various other factors.

</details>

<details>

<summary>What is the max payload size?</summary>

The maximum payload size for `buffered executions` is `4.5mb` per request. For `streamed executions`, we use a payload restriction size of `20mb` per request.

</details>

<details>

<summary>What is the recommended way to call the API?</summary>

If you can, call the API using the `POST` method. The `GET` method works but is not recommended, especially when you're calling it by directly modifying the URL. This is because URL parameters that are strings, can sometimes be misformatted afterwards, and then incorrectly passed to the API.

</details>

<details>

<summary>Can this API handle terms, or should it be a number?</summary>

This API deals only with numbers to solve the quadratic equation, and not terms.

</details>

***

## OpenAPI

You can download the OpenAPI specification for this API to learn more about how it works and how to use it. The OpenAPI specification is a standard, language-agnostic interface to RESTful APIs that allows both humans and computers to discover and understand the capabilities of the service without access to source code, documentation, or through network traffic inspection.

[Download OpenAPI Specification](https://infinitode.netlify.app/openapi/quadratic-equation-solver/openapi.yaml)

***

## Conclusion

That's it! You now have the basics to use the Quadratic Equation Solver API. If you have any further questions or encounter issues, please contact our support team.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://infinitode-docs.gitbook.io/documentation/api-documentation/quadratic-equation-solver-api-documentation.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
